]> TLD Linux GIT Repositories - packages/mysql.git/blob - mysql.init
- keep common dirs for mysqlrouter in mysql-common, fix /var/{lib,log} dirs
[packages/mysql.git] / mysql.init
1 #!/bin/sh
2 #
3 # mysql         A very fast and reliable SQL database engine
4 #
5 # chkconfig:    2345 84 25
6 #
7 # description:  A very fast and reliable SQL database engine.
8
9 # Source function library
10 . /etc/rc.d/init.d/functions
11
12 # Get network config
13 . /etc/sysconfig/network
14
15 # Get service config
16 if [ -f /etc/sysconfig/mysql-@mysqlversion@ ]; then
17         . /etc/sysconfig/mysql-@mysqlversion@
18 else
19         nls "Error: %s not found" /etc/sysconfig/mysql-@mysqlversion@
20         nls "%s can't be run." MySQL
21         exit 1
22 fi
23
24 if [ -n "$MYSQL_DB_CLUSTERS" ]; then
25         nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/@mysqlversion@/clusters.conf
26 fi
27
28 if [ -f /etc/mysql/@mysqlversion@/clusters.conf ]; then
29         MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/@mysqlversion@/clusters.conf)
30         if [ -z "$MYSQL_DB_CLUSTERS" ]; then
31                 nls "Warning: there are no configured clusters."
32         fi
33
34 else
35         nls "Warning: Missing clusters config file %s" /etc/mysql/@mysqlversion@/clusters.conf
36         if [ -z "$MYSQL_DB_CLUSTERS" ]; then
37                 nls "Warning: there are no configured clusters."
38                 nls "Using default cluster /var/lib/mysql (compatibility mode)"
39                 MYSQL_DB_CLUSTERS=/var/lib/mysql
40         fi
41 fi
42
43
44 # Check that networking is up
45 if is_yes "${NETWORKING}"; then
46         if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
47                 msg_network_down MySQL
48                 exit 1
49         fi
50 else
51         exit 0
52 fi
53
54 sharedir=/usr/share/mysql/@mysqlversion@
55
56 action="$1"
57
58 # any db cluster as command line argument?
59 if [ $# -gt 1 ]; then
60         shift
61         # perform action for specified clusters only
62         for a in "$@"; do
63                 # try auto resolving from /etc/mysql/@mysqlversion@/clusters.conf
64                 if [[ "$a" != /* ]]; then
65                         m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/@mysqlversion@/clusters.conf)
66                         if [ -z "$m" ]; then
67                                 echo >&2 "Cluster name '$a' did not match anything!"
68                                 exit 1
69                         fi
70                         if [ $(echo "$m" | wc -l) -gt 1 ]; then
71                                 echo >&2 "Cluster name '$a' ambiguous:" $m
72                                 exit 1
73                         fi
74                         a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/@mysqlversion@/clusters.conf)
75                 fi
76                 DB_CLUSTERS="$DB_CLUSTERS $a"
77         done
78 else
79         DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
80 fi
81
82 # global error log, if mysqld.conf hasn't migrated to log-error style
83 MYSQL_ERRLOG=/var/log/mysql/@mysqlversion@/mysql.log
84 MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
85
86 #
87 # Useful functions.
88 #
89
90 #
91 # check for mysql status
92 #
93 # arguments:
94 # $1 - db cluster
95 # $2 - start|stop
96 #
97 # sets variables:
98 # MYSQL_STATUS = starting | running | not running | died
99 # MYSQL_PID    = pid of mysqld process
100 #
101 mysqlstatus() {
102         clusterdir="$1"
103         mode="$2"
104         
105         mysqlgetconfig "$clusterdir" status
106
107         MYSQL_STATUS="not running"
108         MYSQL_PID="unknown"
109         MYSQL_PIDFILE_PID=""
110         MYSQL_GREP_PID=""
111
112         if [ -f "$MYSQL_PIDFILE" ]; then
113                 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114         fi
115         
116         if [ -n "$MYSQL_PIDFILE_PID" ]; then
117                 MYSQL_PID=$MYSQL_PIDFILE_PID
118                 if [ ! -d "/proc/$MYSQL_PID" ]; then
119                         MYSQL_STATUS="died"
120                         return
121                 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
122                         MYSQL_STATUS="running"
123                         return
124                 fi
125         fi
126
127         if [ "$mode" = "start" ]; then
128                 MYSQL_GREP_PID=$(grep -alE "^@mysqlsbindir@/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
129                 if [ -n "$MYSQL_GREP_PID" ]; then
130                         MYSQL_PID=$MYSQL_GREP_PID
131                         if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
132                                 if [ -f "$MYSQL_PIDFILE" ]; then
133                                         MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134                                 fi
135                                 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136                                         MYSQL_PID=$MYSQL_PIDFILE_PID
137                                         MYSQL_STATUS="running"
138                                         return
139                                 else
140                                         MYSQL_STATUS="starting"
141                                         return
142                                 fi
143                         fi
144                 fi
145         fi
146
147         # else default, "not running"
148 }
149
150 # get mysql configuration in variables
151 # MYSQL_CONFIG MYSQL_CLUSTER_DIR
152 # MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
153 #
154 # arguments
155 # $1 - db cluster
156 # $2 - status | other
157
158 mysqlgetconfig() {
159         local clusterdir="$1" config_file
160         local mode="$2"
161
162         local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/@mysqlversion@/clusters.conf)
163         if [[ $config = /* ]]; then
164                 config_file="$config"
165         elif [ -f "/etc/mysql/@mysqlversion@/$config" ]; then
166                 config_file="/etc/mysql/@mysqlversion@/$config"
167         else
168                 config_file="$clusterdir/mysqld.conf"
169         fi
170
171         MYSQL_CLUSTER_DIR="$clusterdir"
172
173         if [ -z "$config_file" ]; then
174                 nls "Error: Can't find config file for %s cluster" "$clusterdir"
175                 if [ "$mode" = "status" ]; then 
176                         exit 3
177                 else
178                         exit 6
179                 fi
180         else
181                 MYSQL_CONFIG="$config_file"
182         fi
183
184         if [ ! -f "$config_file" ]; then
185                 nls "Error: config file %s not found" "$config_file"
186                 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
187                 if [ "$mode" = "status" ]; then 
188                         exit 3
189                 else
190                         exit 6
191                 fi
192         fi
193
194         # reset to initial state
195         MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
196
197         eval `awk -F= '
198         {
199                 # undos
200                 gsub(/\r$/, "");
201
202                 # trim spaces
203                 gsub(/^[\t ]+|[\t ]+$/, "", $1);
204                 gsub(/^[\t ]+|[\t ]+$/, "", $2);
205         }
206
207         # skip comments and empty lines
208         /^[;#]|^ *$/ { next }
209
210         /^[ \t]*\[.*\][ \t]*$/ {
211                 match($0, /\[.*\]/);
212                 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
213                 next;
214         }
215
216         section == "mysqld" {
217                 if ($1 == "datadir") {
218                         printf("MYSQL_DATA_DIR=%s;", $2);
219                 } else if ($1 == "user") {
220                         printf("MYSQL_USER=%s;", $2);
221                 } else if ($1 == "pid-file") {
222                         printf("MYSQL_PIDFILE=%s;", $2);
223                 } else if ($1 == "socket") {
224                         printf("MYSQL_SOCKET=%s;", $2);
225                 } else if ($1 == "port") {
226                         printf("MYSQL_PORT=%s;", $2);
227                 } else if ($1 == "bind-address") {
228                         printf("MYSQL_BIND_ADDRESS=%s;", $2);
229                 } else if ($1 == "skip-networking") {
230                         printf("MYSQL_SKIP_NETWORKING=1;");
231                 } else if ($1 == "log-error") {
232                         printf("MYSQL_LOG_ERROR=%s;", $2);
233                 }
234         }
235         ' $config_file`
236
237         # error log not defined in config file. add one
238         if [ -z "$MYSQL_LOG_ERROR" ]; then
239                 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
240         else
241                 # unset, so mysqld would use value from config itself
242                 unset MYSQL_LOG_ERROR
243         fi
244
245         MYSQL_DATA_DIR_SUB="/mysqldb"
246
247         if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
248                 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
249                 nls " MySQL can't be run."
250                 exit 6
251         fi
252
253         if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
254                 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
255                 nls " MySQL can't be run."
256                 exit 6
257         fi
258
259         if [ -z "$MYSQL_USER" ]; then
260                 echo "$(nls 'MySQL user not configured properly')"'!' >&2
261                 nls "Edit %s and configure it." "$config_file" >&2
262                 exit 6
263         fi
264 }
265
266 # start mysql
267 mysqlstart() {
268         local clusterdir="$1"
269         mysqlgetconfig "$clusterdir"
270         if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
271                 nls "MySQL cluster %s not initialized." "$clusterdir"
272                 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
273                 exit 6
274         fi
275
276         msg_starting "MySQL $clusterdir"; busy
277         [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
278         rm -f "$MYSQL_PIDFILE"
279
280
281         TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
282                 /usr/bin/setsid @mysqlsbindir@/mysqld \
283                         --defaults-file=$MYSQL_CONFIG \
284                         --datadir=$MYSQL_DATA_DIR \
285                         --pid-file=$MYSQL_PIDFILE \
286                         ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
287                         $MYSQL_OPTIONS &
288         pid=$!
289
290         sleep 0.1
291         mysqlstatus "$clusterdir" start
292         # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
293         if [ "$MYSQL_STATUS" = "starting" ]; then
294                 echo ""
295                 show "Waiting for MySQL to start"
296                 busy
297
298                 # while the pid is running, mysql is starting up
299                 # if the pidfile was created, it started up successfully
300                 # if either case fails we break and report status
301                 while true; do
302                         [ -d /proc/$pid ] || break
303                         [ -f "$MYSQL_PIDFILE" ] && break
304                         sleep 0.2
305                 done
306         fi
307
308         mysqlstatus "$clusterdir" start
309         if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
310                 ok
311         elif [ "$MYSQL_STATUS" = "died" ]; then
312                 RETVAL=1
313                 died
314         else
315                 RETVAL=1
316                 fail
317         fi
318 }
319
320 # stop mysql
321 mysqlstop() {
322         local clusterdir="$1"
323         mysqlstatus "$clusterdir" stop
324         msg_stopping "MySQL $clusterdir"
325         busy
326
327         # try graceful shutdown -- send shutdown command
328         # requires mysql_sysadmin user proper privs
329         @mysqlbindir@/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
330         mysqlstatus "$clusterdir" stop
331
332         if [ "$MYSQL_PID" != "unknown" ]; then
333                 kill -TERM "$MYSQL_PID" 2> /dev/null
334                 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
335                         [ -d "/proc/$MYSQL_PID" ] || break
336                         sleep 0.1
337                 done
338         fi
339         
340         mysqlstatus "$clusterdir" stop
341         if [ "$MYSQL_STATUS" = "died" ]; then
342                 died
343         elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
344                 fail
345         else
346                 ok
347         fi
348 }
349
350 # report slave status
351 # uses MYSQL_SOCKET - path to mysql socket
352 slave_status() {
353         if [ ! -x @mysqlbindir@/mysql ]; then
354                 echo >&2 "Slave status not available: 'mysql' program not installed."
355                 return
356         fi
357
358         # see if slave status can be reported
359         local err=0 slave_status=$(mysql --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" -e 'show slave status\G')
360         if [ -z "$slave_status" ]; then
361                 # slave not setup
362                 return
363         fi
364
365         printf "Slave Status:\n"
366
367         set -f
368         eval $(echo "$slave_status" | awk -F': ' '/^ *[A-Za-z_]+:/{
369                 k = tolower($1);
370                 v = substr($0, length($1) + 3);
371                 gsub(/\\/, "\\\\\\", v);
372                 gsub(/"/, "\\\"", v);
373                 gsub(/`/, "\\`", v);
374                 gsub(/\$/, "\\$", v);
375                 gsub(/\$/, "\\$", v);
376                 printf("%s=\"%s\";\n", k, v);
377         }')
378         set +f
379
380         if [ "$slave_io_running" != "Yes" ]; then
381                 printf "\tSlave IO not running\n"
382                 err=1
383         fi
384         if [ "$slave_sql_running" != "Yes" ]; then
385                 printf "\tSlave SQL not running\n"
386                 err=1
387         fi
388
389         if [ "$err" = 1 -a "$last_errno" -gt 0 ]; then
390                 printf "\tERROR %s: %s\n" "$last_errno" "$last_error"
391         fi
392
393         if [ "$master_log_file" != "$relay_master_log_file" ]; then
394                 printf "\tERROR logfile mismatch (%s)\n" "$relay_master_log_file"
395                 err=1
396         fi
397
398         if [ -z "$read_master_log_pos" -o -z "$exec_master_log_pos" ]; then
399                 printf "\tERROR No info about master\n"
400                 err=1
401                 return
402         fi
403
404         diff=$(($read_master_log_pos - $exec_master_log_pos))
405         printf "\tread pos: %s (%s) (host: %s:%d)\n" "$read_master_log_pos" "$master_log_file" "$master_host" "$master_port"
406         printf "\texec pos: %s\n" "$exec_master_log_pos"
407         printf "\tdiff: %s\n" "$diff"
408 }
409
410 #
411 # check for running mysql instances; if any instance is running then
412 # create subsys lock file
413 #
414 mysqlsubsys() {
415         # check for every defined db cluster in sysconfig file
416         for mysqldir in $DB_CLUSTERS; do
417                 mysqlstatus "$mysqldir"
418                 if [ "$MYSQL_STATUS" = "running" ]; then
419                         touch /var/lock/subsys/mysql-@mysqlversion@
420                         return
421                 fi
422         done
423         rm -f /var/lock/subsys/mysql-@mysqlversion@
424 }
425
426 mysqlinit() {
427         local clusterdir="$1"
428
429         if [ -f /etc/mysqld.conf ]; then
430                 nls "Running in \`no cluster compat' mode: can't initialize database."
431                 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
432                 exit 1
433         fi
434
435         if [ -f "$clusterdir/mysqld.conf" ]; then
436                 mysqlgetconfig "$clusterdir"
437         else
438                 MYSQL_USER="mysql"
439                 MYSQL_CLUSTER_DIR="$clusterdir"
440                 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
441                 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
442                 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
443
444                 # this $MYSQL_CONFIG will be created later
445                 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
446         fi
447
448         show "Initializing cluster %s" "$clusterdir"; started
449
450         # Check if not exist init database
451         if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
452                 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
453                 nls "before initializing database."
454                 nls "For now skipping cluster %s." "$clusterdir"
455                 exit 6
456         fi
457
458         show "Initializing MySQL database for $MYSQL_DATA_DIR"
459         busy
460         TMP=/tmp TMPDIR=/tmp
461
462         mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
463         # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
464         chown root:root "$MYSQL_CLUSTER_DIR"
465         chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
466         chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
467
468         if [ -f $sharedir/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
469                 sed -e "
470                         s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
471                         s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
472                         s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
473                         s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
474                 " $sharedir/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
475                 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
476                 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
477         fi
478
479         ok=0
480         @mysqlsbindir@/mysqld \
481                 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
482                 --initialize-insecure \
483                 --skip-grant-tables \
484                 --datadir=$MYSQL_DATA_DIR \
485                 --user=$MYSQL_USER \
486                 --replica-load-tmpdir=$MYSQL_DATA_DIR \
487                 --tmpdir=$MYSQL_DATA_DIR \
488                 --log-error=$MYSQL_ERRLOG \
489                 && ok=1
490         [ -f $MYSQL_DATA_DIR/mysql.ibd ] || ok=0
491
492         if [ "$ok" = 1 ]; then
493                 ok
494                 cat << END_OF_MSG
495
496 PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
497
498 Start database:
499 $ service mysql-@mysqlversion@ start
500
501 and set passwords:
502
503 For 'root' user (ALL privileges, DB admin), paste command with new password:
504 ALTER USER 'root'@'localhost' IDENTIFIED BY 'newpassword';
505 FLUSH PRIVILEGES;
506
507 For 'mysql_sysadmin' (RELOAD, SHUTDOWN and REPLICATION CLIENT privileges):
508 CREATE USER 'mysql_sysadmin'@'localhost' IDENTIFIED BY 'sysnewpassword' PASSWORD EXPIRE NEVER;
509 GRANT RELOAD, SHUTDOWN, REPLICATION CLIENT ON *.* TO 'mysql_sysadmin'@'localhost';
510 FLUSH PRIVILEGES;
511
512
513 Both into command:
514 $ mysql -u root -p --ssl-mode=disabled -S $MYSQL_SOCKET
515
516 NOTE:
517 mysql_sysadmin password should be placed to $MYSQL_CONFIG in
518 mysqladmin section. See the manual for more instructions.
519 (This user is used at logs rotation and server shutdown)
520
521 END_OF_MSG
522         else
523                 fail
524                 cat << END_OF_MSG
525 ERROR:
526 ERROR:
527 ERROR: Installation FAILED!
528 ERROR:
529 ERROR:
530
531 Examine the logs in $MYSQL_ERRLOG for more information. You can
532 also try to start the mysqld daemon with:
533
534 @mysqlsbindir@/mysqld --skip-grant &
535
536 You can use the command line tool mysql to connect to the mysql
537 database and look at the grant tables:
538
539 shell> mysql -u root mysql
540 mysql> show tables
541
542 Try 'mysqld --help' if you have problems with paths. Setting on
543 logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in
544 /var/log/mysql/@mysqlversion/query.log that may be helpful.
545 The latest information about MySQL is available on the web at
546 http://www.mysql.com/.
547
548 Please check TLD Linux site for newer versions of this package.
549
550 Please consult the MySQL manual section: 'Problems running
551 mysql_install_db', and the manual section that describes problems on
552 your OS. Another information source is the MySQL email archive.
553
554 END_OF_MSG
555                 exit 1
556         fi
557
558         # if it's first server, register as default
559         if [ ! -e /var/lib/mysql/@mysqlversion@/mysql.sock ] || [ -L /var/lib/mysql/@mysqlversion@/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/@mysqlversion@/mysql.sock)" ]; then
560                 sock=${MYSQL_SOCKET#/var/lib/mysql/@mysqlversion@/} # make it relative if possible
561                 ln -s "$sock" /var/lib/mysql/@mysqlversion@/mysql.sock
562         fi
563         # same for config, move to /etc
564         if [ ! -e /etc/mysql/@mysqlversion@/mysqld.conf ]; then
565                 mv "$MYSQL_CLUSTER_DIR/mysqld.conf" /etc/mysql/@mysqlversion@/mysqld.conf
566         fi
567 }
568
569 #
570 # End of useful functions.
571 #
572
573 start() {
574         local mysqldir
575         for mysqldir in $DB_CLUSTERS; do
576                 mysqlstatus "$mysqldir" start
577                 if [ "$MYSQL_STATUS" = "running" ]; then
578                         msg_already_running "MySQL $mysqldir"
579                 else
580                         mysqlstart "$mysqldir"
581                 fi
582         done
583         mysqlsubsys
584 }
585
586 stop() {
587         local mysqldir
588         for mysqldir in $DB_CLUSTERS; do
589                 mysqlstatus "$mysqldir" stop
590                 if [ "$MYSQL_STATUS" = "not running" ]; then
591                         msg_not_running "MySQL $mysqldir"
592                 else
593                         mysqlstop "$mysqldir"
594                 fi
595         done
596         mysqlsubsys
597 }
598
599 condrestart() {
600         if [ ! -f /var/lock/subsys/mysql-@mysqlversion@ ]; then
601                 msg_not_running "MySQL"
602                 RETVAL=$1
603                 return
604         fi
605
606         stop
607         start
608 }
609
610 status() {
611         local mysqldir addr port socket pid pids running datadir 
612         RETVAL=3
613         for mysqldir in $DB_CLUSTERS; do
614                 mysqlstatus "$mysqldir"
615                 if [ "$MYSQL_STATUS" = "running" ]; then
616                         RETVAL=0
617                         addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
618                         port=${MYSQL_PORT:-3306}
619                         socket=${MYSQL_SOCKET:-/var/lib/mysql/@mysqlversion@/mysql.sock}
620                         pid=$MYSQL_PID
621                         nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
622                         [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
623                         nls "\tunix: %s\n" "$socket"
624
625                         MYSQL_SOCKET=$socket slave_status
626
627                         pids="$pids/$MYSQL_PID/"
628                         progress "$MYSQL_STATUS"
629                 else
630                         show "MySQL cluster %s" "$mysqldir"
631                         progress "$MYSQL_STATUS" "$CFAIL"
632                 fi
633                 echo
634         done
635
636         for pid in $(/sbin/pidof mysqld); do
637                 if [[ $pids != */$pid/* ]]; then
638                         running="$running $pid"
639                 fi
640         done
641
642         if [ $# = 1 -a "$running" ]; then
643                 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
644                 # see if we can display their status
645                 for pid in $running; do
646                         datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
647                         datadir=${datadir#--datadir=} # strip --datadir
648                         mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
649                         mysqlstatus "$mysqldir"
650                         if [ "$MYSQL_STATUS" = "running" ]; then
651                                 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
652                                 port=${MYSQL_PORT:-3306}
653                                 socket=${MYSQL_SOCKET:-/var/lib/mysql/@mysqlversion@/mysql.sock}
654                                 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
655                                 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
656                                 nls "\tunix: %s\n" "$socket"
657
658                                 MYSQL_SOCKET=$socket slave_status
659
660                                 progress "$MYSQL_STATUS"
661                         else
662                                 show "MySQL cluster %s" "$mysqldir"
663                                 progress "$MYSQL_STATUS" "$CFAIL"
664                         fi
665                         echo
666                 done
667         fi
668 }
669
670 RETVAL=0
671 case "$action" in
672   start)
673         start
674         ;;
675   stop)
676         stop
677         ;;
678   restart)
679         stop
680         start
681         ;;
682   try-restart)
683         condrestart 0
684         ;;
685   force-reload)
686         condrestart 7
687         ;;
688   init)
689         for mysqldir in $DB_CLUSTERS; do
690                 mysqlinit "$mysqldir"
691         done
692         exit $?
693         ;;
694   flush-logs)
695         for mysqldir in $DB_CLUSTERS; do
696                 mysqlgetconfig "$mysqldir"
697                 # just if mysqld is really running
698                 if @mysqlbindir@/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
699                         @mysqlbindir@/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
700                 fi
701         done
702         ;;
703   status)
704         status
705         ;;
706   *)
707         msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
708         exit 3
709 esac
710
711 exit $RETVAL